UART_init:
.equ UBRR_VAL   = ((F_CPU+BAUD*8)/(BAUD*16)-1)  	; clever runden
.equ BAUD_REAL  = (F_CPU/(16*(UBRR_VAL+1)))     	; Reale Baudrate
.equ BAUD_ERROR = ((BAUD_REAL*1000)/BAUD-1000)  	; Fehler in Promille
 
.if ((BAUD_ERROR>10) || (BAUD_ERROR<-10))       	; max. +/-10 Promille Fehler
;.error "Systematischer Fehler der Baudrate grsser 1 Prozent und damit zu hoch!"
.endif
	
	ldi		temp, (1<<RXEN0)|(1<<TXEN0)
	sts		UCSR0B, temp							;Sender u. Empfnger einschalten	
	ldi		temp, (1<<UCSZ01)|(1<<UCSZ00)
	sts		UCSR0C, temp
	lds		temp, UDR0

	ldi		temp,HIGH(UBRR_VAL)
	sts		UBRR0H, temp
	ldi		temp,LOW(UBRR_VAL)						;Teilerformel
	sts		UBRR0L, temp
ret

UART_Fehler:	
	ldi		zl, low(_Fehler*2)
	ldi		zh, high(_Fehler*2)
	rcall	uart_message
ret

UART_Aktion_1:	
	ldi		zl, low(_Aktion_1*2)
	ldi		zh, high(_Aktion_1*2)
	rcall	uart_message
ret

UART_Aktion_2:	
	ldi		zl, low(_Aktion_2*2)
	ldi		zh, high(_Aktion_2*2)
	rcall	uart_message
ret

uart_transmit:									;temp wird ausgegeben
	lds		r10, UCSR0A
	sbrs	r10, UDRE0
	rjmp	UART_Transmit
	sts		UDR0, temp
exit_usart_transmit:
	ret

uart_message:
	lpm		temp, z+
	tst		temp
	breq	exit_uart_message
	rcall	uart_transmit
	rjmp	uart_message
exit_uart_message:
	ret






